<?php
namespace Teknisa\MAN\Factories;

use Doctrine\DBAL\Connection;
use Teknisa\MAN\Utilities;

class FiliaisRepository {

    protected  $connection;
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }

    /**
     * @return array
     */
    public function getMaxId() {
        return $this->connection->fetchAll(Utilities\Query::GET_MAXNRRELESTRUTURATABEPRECO);
    }

    public function getMaxId1() {
        return $this->connection->fetchAll(Utilities\Query::GET_MAXNRRELESTRTURACONFIGURACAO);
    }

    public function checaExistenciaConfig($cdfilial, $nrorg) {
        $params = array(
            "CDFILIAL" => $cdfilial,
            "NRORG" => $nrorg
     	); 
        return $this->connection->fetchAll(Utilities\Query::GET_NRRELESTRTURACONFIGURACAO,$params);
    }

    public function checaExistenciaConfigLoja($cdfilial, $cdloja, $nrorg) {
        $params = array(
            "CDFILIAL" => $cdfilial,
            "CDLOJA" => $cdloja,
            "NRORG" => $nrorg
     	);  
        return $this->connection->fetchAll(Utilities\Query::GET_NRRELESTRTURACONFIGURACAO_BY_CDLOJA, $params);
    }

    public function checaExistenciaConfigCaixa($cdfilial, $cdloja, $cdcaixa, $nrorg) {
        $params = array(
            "CDFILIAL" => $cdfilial,
            "CDLOJA" => $cdloja,
            "CDCAIXA" => $cdcaixa,
            "NRORG" => $nrorg
     	);  
        return $this->connection->fetchAll(Utilities\Query::GET_NRRELESTRTURACONFIGURACAO_BY_CDCAIXA,$params);
    }

    public function checaConfigByFilial($cdfilial, $nrorg) {
        $params = array(
            "CDFILIAL" => $cdfilial,
            "NRORG" => $nrorg
     	); 
        return $this->connection->fetchAll(Utilities\Query::GET_NRRELESTRTURACONFIGURACAO, $params);
    }

    public function checaConfigByFilialLoja($cdfilial, $cdloja, $nrconfiguracao, $nrorg) {
        $params = array(
            "CDFILIAL" => $cdfilial,
            "CDLOJA" => $cdloja,
            "NRSEQCONFIGURACAO" => $nrconfiguracao,
            "NRORG" => $nrorg
     	); 
        return $this->connection->fetchAll(Utilities\Query::GET_NRRELESTRTURACONFIGURACAO_BY_NRSEQCONFIGURACAO, $params);
    }
} 
