<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;

class PrinterParams {

	protected $entityManager;
    protected $util;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager, Utilities\Util $util)  {
		$this->entityManager = $entityManager;
        $this->util          = $util;  
	}

	public function getPrinters ($CDFILIAL, $CDLOJA, $NRORG) {
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':CDLOJA'   => $CDLOJA,
			':NRORG'    => $NRORG
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_IMPRESSORAS, $params);
	}

	public function getProductsForAdd ($CDFILIAL, $CDLOJA, $NRORG) {
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':CDLOJA'   => $CDLOJA,
			':NRORG'   => $NRORG
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_PRODUCTS_FOR_ADD, $params);
	}

	public function getDepartments ($NRORG) {
		$params = array(
			':NRORG'    => $NRORG
		);
		
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_SETORES, $params);
	}

	public function updateProduct ($IDIMPCANITEM, $CDSETOR, $NRSEQIMPRPROD, $NRSEQIMPRPUXA,
									$CDFILIAL, $CDLOJA, $CDPRODUTO) {
		$params = array(
			':IDIMPCANITEM'   => $IDIMPCANITEM,
			':CDSETOR'        => $CDSETOR,
			':NRSEQIMPRPROD'  => $NRSEQIMPRPROD,
			':NRSEQIMPRPUXA'  => $NRSEQIMPRPUXA,
			':CDFILIAL'       => $CDFILIAL,
			':CDLOJA'         => $CDLOJA,
			':CDPRODUTO'      => $CDPRODUTO
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_PRODLOJA, $params);
	}

	public function insertProducts ($CDFILIAL, $CDLOJA, $CDPRODUTO, $CDARVPRODFINAL, $IDIMPCANITEM,
									$CDSETOR, $NRSEQIMPRPROD, $NRSEQIMPRPUXA, $ambientes) {
		if(empty($CDARVPRODFINAL)){
			//se é um produto só insere ele na moral
			$produtos = array(
							array('CDPRODUTO' => $CDPRODUTO
							)
						);
		}else{
			$params = array(
				':CDARVPROD'       => $CDPRODUTO,
				':CDARVPRODFINAL'  => $CDARVPRODFINAL
			);
			$produtos = $this->entityManager->getConnection()->fetchAll(Utilities\Query::SELECT_PRODUCTS_BETWEEN, $params);
		}
		foreach ($produtos as $produto ) {
			$params = array(
				':CDFILIAL'       => $CDFILIAL,
				':CDLOJA'         => $CDLOJA,
				':CDPRODUTO'      => $produto["CDPRODUTO"],
				':IDIMPCANITEM'   => $IDIMPCANITEM,
				':CDSETOR'        => $CDSETOR,
				':NRSEQIMPRPROD'  => $NRSEQIMPRPROD,
				':NRSEQIMPRPUXA'  => $NRSEQIMPRPUXA
			);

			$toInsert = $this->entityManager->getConnection()->fetchAll(Utilities\Query::SELECT_EXPECIFIC_PRODUCT_PRODLOJA, $params);
			if(empty($toInsert)){
		    	$this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERT_PRODLOJA, $params);
			}else{
				$this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_PRODLOJA, $params);
			}
			//$this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_PRODUCT_PRODAMBIENTE, $params);
            foreach (json_decode($ambientes, true) as $ambiente) {
            	$dup_params =  array(
					':CDFILIAL'      => $CDFILIAL,
					':CDLOJA'        => $CDLOJA,
					':CDPRODUTO'     => $produto["CDPRODUTO"],
					':NRCONFTELA'    => $ambiente['NRCONFTELA'],
					':CDAMBIENTE'    => $ambiente['CDAMBIENTE'],
					':NRSEQIMPRLOJA' => $ambiente['NRSEQIMPRLOJA']
				);
                $isInserted = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_PRODAMBIENTE_DUPLICADO, $dup_params);

                if (empty($isInserted) ){

                    $NRPRODAMBIENTE = $this->util->newCode('PRODAMBIENTE'.$CDFILIAL.$CDLOJA.$produto["CDPRODUTO"], 10);

                    $this->insertProdArea(
                        $CDFILIAL,
                        $CDLOJA,
                        $produto["CDPRODUTO"],
                        $NRPRODAMBIENTE,
                        $ambiente['NRCONFTELA'],
                        $ambiente['CDAMBIENTE'],
                        $ambiente['NRSEQIMPRLOJA']
                    );

                }else{
                    $this->updateProdArea(
                        $ambiente['NRCONFTELA'],
                        $ambiente['CDAMBIENTE'],
                        $ambiente['NRSEQIMPRLOJA'],
                        $CDFILIAL,
                        $CDLOJA,
                        $produto["CDPRODUTO"],
                        $isInserted[0]['NRPRODAMBIENTE']
                    );
                }
            }
		}
	}

	public function deleteProduct ($CDFILIAL, $CDLOJA, $CDPRODUTO) {
		$params = array(
			':CDFILIAL'  => $CDFILIAL,
			':CDLOJA'    => $CDLOJA,
			':CDPRODUTO' => $CDPRODUTO
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::REMOVE_PRODLOJA, $params);
	}

	public function getAreas ($CDFILIAL, $NRCONFTELA, $SEARCH) {
		$params = array(
			':CDFILIAL'   => $CDFILIAL,
			':NRCONFTELA' => $NRCONFTELA,
			':SEARCH' => $SEARCH
		);
		return $this->entityManager->getConnection()->fetchAll(self::GET_AMBIENTES, $params);
	}

	public function getProdAreas ($CDFILIAL, $CDLOJA, $CDPRODUTO) {
		$params = array(
			':CDFILIAL'   => $CDFILIAL,
			':CDLOJA'     => $CDLOJA,
			':CDPRODUTO'  => $CDPRODUTO
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_PRODAMBIENTES, $params);
	}
	
	public function getProdArea ($CDFILIAL, $CDLOJA, $CDPRODUTO, $NRPRODAMBIENTE) {
		$params = array(
			':CDFILIAL'   => $CDFILIAL,
			':CDLOJA'     => $CDLOJA,
			':CDPRODUTO'  => $CDPRODUTO,
			':NRPRODAMBIENTE'  => $NRPRODAMBIENTE
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_PRODAMBIENTE, $params);
	}
	
	public function getProdAreaDuplicate ($CDFILIAL, $CDLOJA, $CDPRODUTO, $NRCONFTELA, $CDAMBIENTE, $NRSEQIMPRLOJA) {
		$params = array(
			':CDFILIAL'      => $CDFILIAL,
			':CDLOJA'        => $CDLOJA,
			':CDPRODUTO'     => $CDPRODUTO,
			':NRCONFTELA'    => $NRCONFTELA,
			':CDAMBIENTE'    => $CDAMBIENTE,
			':NRSEQIMPRLOJA' => $NRSEQIMPRLOJA
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_PRODAMBIENTE_DUPLICADO, $params);
	}
	
	public function getProdAreaDuplicateEdit ($CDFILIAL, $CDLOJA, $CDPRODUTO, $NRCONFTELA, $CDAMBIENTE, $NRSEQIMPRLOJA, $NRPRODAMBIENTE) {
		$params = array(
			':CDFILIAL'       => $CDFILIAL,
			':CDLOJA'         => $CDLOJA,
			':CDPRODUTO'      => $CDPRODUTO,
			':NRCONFTELA'     => $NRCONFTELA,
			':CDAMBIENTE'     => $CDAMBIENTE,
			':NRSEQIMPRLOJA'  => $NRSEQIMPRLOJA,
			':NRPRODAMBIENTE' => $NRPRODAMBIENTE
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_PRODAMBIENTE_DUPLICADO_EDIT, $params);
	}

	public function getConfScreen ($CDFILIAL, $CDLOJA) {
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':CDLOJA'   => $CDLOJA
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_CONFTELA, $params);
	}

	public function insertProdArea ($CDFILIAL, $CDLOJA, $CDPRODUTO, $NRPRODAMBIENTE, $NRCONFTELA,
									$CDAMBIENTE, $NRSEQIMPRLOJA, $DTINIVIGENCIA) {
		$params = array(
			':CDFILIAL'       => $CDFILIAL,
			':CDLOJA'         => $CDLOJA,
			':CDPRODUTO'      => $CDPRODUTO,
			':NRPRODAMBIENTE' => $NRPRODAMBIENTE,
			':NRCONFTELA'     => $NRCONFTELA,
			':CDAMBIENTE'     => $CDAMBIENTE,
			':NRSEQIMPRLOJA'  => $NRSEQIMPRLOJA,
			':DTINIVIGENCIA'  => $DTINIVIGENCIA
		);

		return $this->entityManager->getConnection()->executeQuery(self::INSERT_PRODAMBIENTE, $params);
	}

	public function deleteProdArea ($CDFILIAL, $CDLOJA, $CDPRODUTO, $NRPRODAMBIENTE) {
		$params = array(
			':CDFILIAL'       => $CDFILIAL,
			':CDLOJA'         => $CDLOJA,
			':CDPRODUTO'      => $CDPRODUTO,
			':NRPRODAMBIENTE' => $NRPRODAMBIENTE
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_PRODAMBIENTE, $params);
	}
	public function deleteProdAreaByProduto ($CDFILIAL, $CDLOJA, $CDPRODUTO) {
		$params = array(
			':CDFILIAL'       => $CDFILIAL,
			':CDLOJA'         => $CDLOJA,
			':CDPRODUTO'      => $CDPRODUTO
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_PRODAMBIENTE_PRODUTO, $params);
	}

	public function updateProdArea ($NRCONFTELA, $CDAMBIENTE, $NRSEQIMPRLOJA, $CDFILIAL,
									$CDLOJA, $CDPRODUTO, $NRPRODAMBIENTE) {
		$params = array(
			':NRCONFTELA'     => $NRCONFTELA,
			':CDAMBIENTE'     => $CDAMBIENTE,
			':NRSEQIMPRLOJA'  => $NRSEQIMPRLOJA,
			':CDFILIAL'       => $CDFILIAL,
			':CDLOJA'         => $CDLOJA,
			':CDPRODUTO'      => $CDPRODUTO,
			':NRPRODAMBIENTE' => $NRPRODAMBIENTE
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_PRODAMBIENTE, $params);
	}

	public function beginTransaction () {
		$this->entityManager->getConnection()->beginTransaction();
	}

	public function commit() {
		$this->entityManager->getConnection()->commit();
	}

	public function rollBack() {
		$this->entityManager->getConnection()->rollBack();
	}
	
	public function cadlojaExcluirImprossoraAmbiente ($rows){
		$this->beginTransaction();
		try{
			$params = array(
				":CDFILIAL"=>$rows['CDFILIAL'],
                ":CDLOJA"=>$rows['CDLOJA'],
                ":NRCONFTELA"=>$rows['NRCONFTELA'],
                ":CDAMBIENTE"=>$rows['CDAMBIENTE'],
                ":NRSEQIMPRLOJA"=>$rows['NRSEQIMPRLOJA'],
                ":NRORG"=>$rows['NRORG']		
			);
			$this->entityManager->getConnection()->executeQuery(self::DELETE_PRODAMBIENTE_AUTOMATICO, $params);
			$this->commit();
		}catch(\Exception $e){
			$this->rollBack();
			throw $e;
		}
	}
	
	const DELETE_PRODAMBIENTE_AUTOMATICO = "
		DELETE FROM PRODAMBIENTE
              WHERE CDFILIAL       = :CDFILIAL
                AND CDLOJA         = :CDLOJA
                AND NRCONFTELA = :NRCONFTELA
                AND CDAMBIENTE = :CDAMBIENTE
                AND NRSEQIMPRLOJA = :NRSEQIMPRLOJA
                AND NRORG = :NRORG
	";
	
	const INSERT_PRODAMBIENTE = "
        INSERT INTO PRODAMBIENTE
            (CDFILIAL, CDLOJA, CDPRODUTO, NRPRODAMBIENTE, NRCONFTELA, CDAMBIENTE, NRSEQIMPRLOJA, DTINIVIGENCIA)
        VALUES
            (:CDFILIAL, :CDLOJA, :CDPRODUTO, :NRPRODAMBIENTE, :NRCONFTELA, :CDAMBIENTE, :NRSEQIMPRLOJA, :DTINIVIGENCIA)
    ";
    
       const GET_AMBIENTES = "
        SELECT CDAMBIENTE, NMAMBIENTE, CDAMBIENTE || ' - ' || NMAMBIENTE AS LABELAMBIENTE
          FROM AMBIENTES
         WHERE CDFILIAL = :CDFILIAL
           AND NRCONFTELA = :NRCONFTELA
           AND UPPER(CDAMBIENTE || NMAMBIENTE) LIKE UPPER(:SEARCH)
    ";
}