<?php

namespace Teknisa\MAN\Services;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;
use \Setforms2\Shared\ORM\DateTime;

class RelCancelamentoCupomService {

	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}

	private function addParams($conditions,$param) {

        if(!array_key_exists($param, $conditions)) {
            $conditions[$param] = '';
            $conditions['T'.$param] = 'T';
        }else{
            $conditions[$param] = implode('_', $conditions[$param]);
            $conditions['T'.$param] = '';
        }
        return $conditions;
    }

	public function getCupons($conditions) {
	    $conditions = $this->addParams($conditions,'CDFILIAL');
	    $conditions = $this->addParams($conditions,'CDFILICAIXA');
		$params = array(
			':CDFILIAL' => $conditions['CDFILIAL'],
			':TCDFILIAL' => $conditions['TCDFILIAL'],
		    ':CDFILICAIXA'  => $conditions['CDFILICAIXA'],
		    ':TCDFILICAIXA'  => $conditions['TCDFILICAIXA'],
			':NRORG'    => $conditions['NRORG'],
		    ':DTFIM'    => $conditions['DTENTRVENDA'][1],
		    ':DTINI'   => $conditions['DTENTRVENDA'][0]
		);
		return $this->entityManager->getConnection()->fetchAll(self::GET_CUPOM_CANCELADO, $params);
	}

	const GET_CUPOM_CANCELADO = "
     SELECT DECODE(V.IDTPEMISVEND,'S',V.NRNOTAFISCALCE,DECODE(V.IDTPEMISVEND,'N',V.NRNOTAFISCALCE,V.NRCUPOMFIS)) AS CUPOM,  V.CDFILIAL, F.NMFILIAL, L.NMLOJA, V.NRSEQVENDA, V.CDCAIXA, V.CDOPERADOR, OP.NMOPERADOR, V.CDSUPERVISOR, OP2.NMOPERADOR AS NMSUPERVISOR, V.DTVENDA, V.CDLOJA, V.NRORG,
        CASE SUBSTR(V.IDORIGEMVENDA, 0, 3)
        WHEN 'DLV' THEN 'Delivery'
        WHEN 'MES' THEN 'Mesa'
        WHEN 'CMD' THEN 'Comanda'
        WHEN 'BAL' THEN 'Balcão'
        ELSE 'Outro'
        END IDORIGEMVENDA,
        CASE V.IDTPEMISVEND
        WHEN 'S' THEN 'SAT'
        WHEN 'E' THEN 'ECF'
        WHEN 'N' THEN 'N-FCE'
        ELSE 'Outros'
        END IDTPEMISVEND,
        TRUNC(SUM((I.QTPRODVEND * (I.VRUNITVEND + I.VRUNITVENDCL)) + I.VRACRITVEND - I.VRDESITVEND), 2) AS VALOR,
        V.CDFILIAL || ' - ' || F.NMFILIAL || ' - Loja: ' || V.CDLOJA || ' - ' || L.NMLOJA AS LABELFILIAL
        FROM VENDA V
        JOIN ITEMVENDA I
        ON V.CDFILIAL = I.CDFILIAL
        AND V.NRSEQVENDA = I.NRSEQVENDA
        AND V.CDCAIXA = I.CDCAIXA
        AND V.NRORG = I.NRORG
        JOIN FILIAL F
        ON V.CDFILIAL = F.CDFILIAL
        AND V.NRORG = F.NRORG
        JOIN LOJA L
        ON V.CDFILIAL = L.CDFILIAL
        AND V.CDLOJA = L.CDLOJA
        AND V.NRORG = L.NRORG
        JOIN CAIXA C
        ON V.CDFILIAL = C.CDFILIAL
        AND V.CDLOJA = C.CDLOJA
        AND V.CDCAIXA = C.CDCAIXA
        AND V.NRORG = C.NRORG
        JOIN OPERADOR OP
        ON OP.NRORG = :NRORG
        AND OP.CDOPERADOR = V.CDOPERADOR
        LEFT JOIN OPERADOR OP2
        ON OP2.NRORG = :NRORG
        AND OP2.CDOPERADOR = V.CDSUPERVISOR
        WHERE V.IDSITUVENDA = 'C'
        AND (INSTR(:CDFILIAL, V.CDFILIAL) <> 0 OR (:TCDFILIAL = 'T' ))
        AND ((INSTR(:CDFILICAIXA , V.CDFILIAL||V.CDCAIXA) <> 0 ) OR (:TCDFILICAIXA = 'T'))
        AND V.NRORG = :NRORG
        AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIM
        GROUP BY DECODE(V.IDTPEMISVEND,'S',V.NRNOTAFISCALCE,DECODE(V.IDTPEMISVEND,'N',V.NRNOTAFISCALCE,V.NRCUPOMFIS)),  V.CDFILIAL,F.NMFILIAL, L.NMLOJA, V.NRSEQVENDA, V.CDCAIXA,V.CDOPERADOR, OP.NMOPERADOR, V.CDSUPERVISOR, OP2.NMOPERADOR, V.DTVENDA, V.CDLOJA, V.NRORG, V.IDORIGEMVENDA, V.IDTPEMISVEND
        ORDER BY V.CDFILIAL, V.CDLOJA, V.CDCAIXA, V.DTVENDA";
}
